﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading.Tasks;

namespace WSUniversalLib
{
    public class Calculation
    {
        /// <summary>
        /// Метод для определения количества сырья для изготовления продукции
        /// </summary>
        /// <param name="productType">тип продукта</param>
        /// <param name="materialType">тип материала</param>
        /// <param name="count">количество</param>
        /// <param name="width">ширина</param>
        /// <param name="length">длина</param>
        /// <returns></returns>
        public static int GetQuantityForProduct(int productType, int materialType, int count, float width, float length)
        {
            try
            {
                float square = width * length;
                float coefficient = 0;
                switch (productType)
                {
                    case 1:
                        coefficient = 1.1F;
                        break;
                    case 2:
                        coefficient = 2.5F; 
                        break;
                    case 3:
                        coefficient=8.43F;
                        break;
                    default:
                        return -1;
                }
                float count_material = square * coefficient;

                float defect = 0;
                switch (materialType)
                {
                    case 1:
                        defect = 0.003F;
                        break;
                    case 2:
                        defect = 0.0012F;
                        break;
                    default:
                        return -1;
                }
                float result_material = count * count_material / (1 - defect);

                return (int)result_material;

            }
            catch (Exception)
            {
                return -1;
                
            }

        }
    }
}
